#include<bits/stdc++.h>
using namespace std;
#define ll long long

ll powc(ll x, ll d)
{
    return exp((1.0/d)*log(x));
}

ll powlt(ll x, ll d)
{
    ll t=1;
    for(int i=1; i<=d; i++)
        t=t*x;
    return t;
}

bool check(ll x, ll d) {
	ll y = powc(x,d);
	return x == (ll)powlt(y, d) || x == (ll)powlt(y+1, d);
}

ll dinhly(ll n) {
	if(check(n, 2)) return 1;
	while (n % 4 == 0) n /= 4;
	if (n % 8 == 7) return 4;
	for (ll i = 1; i*i <= n; i++) {
		if (check(n - i*i,2)) return 2;
	}
	return 3;
}

int solve() {
	ll n; cin >> n;
	if(check(n,2)) return 2;
	else if(check(n,3)) return 3;
	else {
		int d = dinhly(n);
		if(d == 2) return 4;
		else {
			bool ok = false;
			for(ll i = 1; i*i*i < n; i++) {
				ll tmp = n - i*i*i;
				if(check(tmp, 2)) {
					ok = true;
					break;
				}
			}
			if(ok || check(n,5)) return 5;
			else {
				if(d == 3) return 6;
				else {
					for(ll i = 1; i*i*i < n; i++) {
						ll tmp = n - i*i*i;
						if(check(tmp, 3)) {
							return 6;
						}
					}
					ok = false;
					for(ll i = 1; i*i*i < n; i++) {
						ll tmp = n - i*i*i;
						if(dinhly(tmp) == 2) {
							ok = true;
							break;
						}
					}
					for(ll i = 1; i*i < n; i++) {
						ll tmp = n - i*i;
						if(check(tmp, 5)) {
							return 7;
						}
					}
					if(ok || check(n,7)) return 7;
					else return 8;
				}
			}
		}
	}
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    freopen("HOCMAY.INP","r",stdin);
    freopen("HOCMAY.OUT","w",stdout);
	int t; cin >> t;
	while(t--) cout << solve() << endl;
	return 0;
}
